package oscar

import oscar.cp._

/**
 * Compute a sequence a_i (0 <= i < 10) such that the sequence contains exactly a_i occurrences of i.
 */
object MagicSerie extends CPModel with App {
  //
  // data
  //
  val n = 300
  //
  // variables
  //
  val x = Array.fill(n)(CPIntVar(0 to n - 1))


  add(sum(x,CPIntVar(n)))

  for (i <- 0 until n) {
    add((sum(0 until n)(k => x(k) ?=== i)) ===  x(i))
  }

  search {
    binaryIdx(x,i => (x(i).size,i), i => x(i).min)
  }

  onSolution {
    println("\nSolution:")
    println("x: " + x.mkString(" "))
  }
  println(start())


}